MeshCapper.CapVertex
Date: 2019-10-22

org.jmol.util

## Class MeshCapper.CapVertex

- java.lang.Object
- - javajs.util.T3
  - - org.jmol.util.MeshCapper.CapVertex

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, javajs.api.JSONEncodable
  Enclosing class:
    MeshCapper

      private class MeshCapper.CapVertex
      extends javajs.util.T3
      implements java.lang.Cloneable

  A class to provide linked vertices for MeshCapper

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) java.lang.String` | `id` for debugging
    `(package private) int` | `ipt` external reference
    `(package private) MeshCapper.CapVertex` | `next`
    `(package private) MeshCapper.CapVertex` | `prev` edge double links
    `(package private) MeshCapper.CapVertex[]` | `region` dynamic region pointers
    `protected MeshCapper.CapVertex` | `yxNext` Y-X scan queue forward link

    - ### Fields inherited from class javajs.util.T3

      `x, y, z`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CapVertex(javajs.util.T3 p, int i)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `clear()` Free all links.
    `MeshCapper.CapVertex` | `cloneV()`
    `private java.lang.String` | `dumpRegion()` for debugging
    `protected float` | `interpolateX(MeshCapper.CapVertex v1, MeshCapper.CapVertex v2)` Get interpolated x for the scan line intersection with an edge.
    `protected void` | `link(MeshCapper.CapVertex v)` Link this vertex with v or remove it from the chain.
    `java.lang.String` | `toString()` Returns a string that contains the values of this Tuple3f.

    - ### Methods inherited from class javajs.util.T3

      `add, add2, add3, ave, cross, distance, distanceSquared, dot, equals, floatToIntBits, hashCode, length, lengthSquared, normalize, scale, scaleAdd2, scaleT, set, setA, setT, sub, sub2, toJSON`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### ipt

          int ipt

      external reference

    - #### id

          java.lang.String id

      for debugging

    - #### yxNext

          protected MeshCapper.CapVertex yxNext

      Y-X scan queue forward link

    - #### prev

          MeshCapper.CapVertex prev

      edge double links

    - #### next

          MeshCapper.CapVertex next

    - #### region

          MeshCapper.CapVertex[] region

      dynamic region pointers

  - ### Constructor Detail

    - #### CapVertex

          CapVertex(javajs.util.T3 p,
                    int i)

  - ### Method Detail

    - #### cloneV

          public MeshCapper.CapVertex cloneV()

    - #### interpolateX

          protected float interpolateX(MeshCapper.CapVertex v1,
                                       MeshCapper.CapVertex v2)

      Get interpolated x for the scan line intersection with an edge. This method is used both in finding the last point for a split and for checking winding on same-side addition. determine
      Parameters:
        `v1` -
        `v2` -
      Returns:
        x

    - #### link

          protected void link(MeshCapper.CapVertex v)

      Link this vertex with v or remove it from the chain.
      Parameters:
        `v` - null to remove

    - #### clear

          protected void clear()

      Free all links.

    - #### dumpRegion

          private java.lang.String dumpRegion()

      for debugging
      Returns:
        listing of vertices currently in a region

    - #### toString

          public java.lang.String toString()

      Description copied from class: `javajs.util.T3`
      Returns a string that contains the values of this Tuple3f. The form is (x,y,z).
      Overrides:
        `toString` in class `javajs.util.T3`
      Returns:
        the String representation